function deftfmou(arg1)
%DEFTFMOU Auxiliary file for program deftf (interactive for TFI).

% TFI Environment (A.Civolani & G.Marro) - 1994-96. Matlab5 version, 1997.

global nfig pbs VV gr str repco HA HA1 HA2 ncol mess1 mess2 mx1 mx2...
 zcomp pcomp kcomp kcomps TT mens men_gr gj vcol1 vcol2...
 stkn1 stkd1 stkn2 stkd2 stkn3 stkd3 stkn4 stkd4 stkn5 stkd5 stkn6 stkd6...
 stkn7 stkd7 TSAMP HALEG FIGLEG LABLEG SUBPLEG SC

nfig=gcf; nfigs=int2str(nfig); flg1=0; gr=0; frame=.1;
HA=[]; HA1=[]; ncol=1; HA2=[]; gj=arg1; pbs=zeros(1,70); FIGLO=resfiglo;
zcomp=[]; pcomp=[]; kcomp=1; kcomps=1; stkn1=1; stkd1=1; stkn2=1; stkd2=1;
stkn3=1; stkd3=1; stkn4=1; stkd4=1; stkn5=1; stkd5=1; stkn6=1; stkd6=1;
stkn7=1; stkd7=1; fleg=0; NPKK=0; err='err'; str=[];
FIGLEG=0; HALEG=[]; LABLEG=[]; SUBPLEG=0;
if exist('legen#.mat'), load legen#, else, legen=0; islegen=0; end
%
ddd=input('\n   discrete-time ? (1) : ');
if isempty(ddd), ddd=0; end
if ddd==1
 str='z';
else
 str='s';
end
clf, ordf(3), hold off, framesc=get(0,'DefaultFigureColor');
VFULL=get(gcf,'Position'); PO=get(gca,'Position');
SC=diag([1/VFULL(3);1/VFULL(4);1/VFULL(3);1/VFULL(4)]);
set(0,'DefaultUIControlUnits','normalized')
if any(FIGLO(4,:))
 eval('set(nfig,''Position'',FIGLO(4,1:4))','erx=1;') %5.3
end
[vcol1,vcol2,repco,repcos]=coltbl; colbg=vcol1(8,:); set(gcf,'Color',colbg),
%
nfig1=nfig+1; figure(nfig1), clf, ordf(6) %5.3
if any(FIGLO(4,:))
 eval('set(nfig1,''Position'',FIGLO(4,5:8))','erx=1;')
end
men_opt1=uimenu(gcf,'Label','Recall'); pbs(31)=men_opt1;
men1=uimenu(gcf,'Label','Time axis'); pbs(61)=men1;
uimenu(men1,'Label','enlarge x 2',...
'Callback','deftfaux(25)');
uimenu(men1,'Label','enlarge x 5','Separator','on',...
'Callback','deftfaux(26)');
uimenu(men1,'Label','enlarge x 10','Separator','on',...
'Callback','deftfaux(27)');
uimenu(men1,'Label','recover the initial axis','Separator','on',...
'Callback','deftfaux(28)');
men_gr1=uimenu(gcf,'Label','Grid on/off','Callback','grid');
pbs(62)=men_gr1; set(pbs(31),'Enable','off')
set(pbs(61),'Enable','off'), set(pbs(62),'Enable','off')
BB=VFULL(4);
Pos=[150 BB-120 200 20]*SC;
pbs(25)=uicontrol(gcf,...
'Style','Text',...
'Position',Pos,...
'BackgroundColor',colbg,...
'ForegroundColor',vcol2(2,:),...
'Visible','off',...
'String','WAIT, PLEASE');
Pos=[20 5 50 20]*SC;
pbs(26)=uicontrol(gcf,...
'Style','push',...
'Position',Pos,...
'Visible','off',...
'String','Menu',...
'Callback','deftfaux(30)');
%
nfig2=nfig+2; figure(nfig2), clf, ordf(7) %5.3
if any(FIGLO(4,:))
 eval('set(nfig2,''Position'',FIGLO(4,9:12))','erx=1;')
end
men_opt2=uimenu(gcf,'Label','Recall'); pbs(32)=men_opt2;
men_gr2=uimenu(gcf,'Label','Grid on/off','Callback','gridmng(6)');
pbs(64)=men_gr2; set(pbs(32),'Enable','off'), set(pbs(64),'Enable','off')
BB=VFULL(4);
Pos=[150 BB-120 200 20]*SC;
pbs(27)=uicontrol(gcf,...
'Style','Text',...
'Position',Pos,...
'BackgroundColor',colbg,...
'ForegroundColor',vcol2(2,:),...
'Visible','off',...
'String','WAIT, PLEASE');
Pos=[20 5 50 20]*SC;
pbs(28)=uicontrol(gcf,...
'Style','push',...
'Position',Pos,...
'Visible','off',...
'String','Menu',...
'Callback','deftfaux(30)');
%
figure(nfig1), figure(nfig)
%
j=sqrt(-1);
%
%  TOP MENU
%
mens=uimenu(gcf,'Label','Change axes');
mens1=uimenu(mens,'Label','x left');
mens2=uimenu(mens,'Label','x right');
mens3=uimenu(mens,'Label','y, up and down','Separator','on');
%
men_gr=uimenu(nfig,'Label','Grids');
uimenu(men_gr,'Label','Grid on/off','Callback','gridmng(1)');
uimenu(men_gr,'Label','Constant damping loci on/off',...
'Callback','gridmng(5)');
%
uimenu(mens1,...
'Label','enlarge by 1 tick',...
'Callback','deftfaux(11)');
uimenu(mens1,...
'Label','enlarge by 2',...
'Callback','deftfaux(17)');
uimenu(mens1,...
'Label','reduce by 1 tick',...
'Callback','deftfaux(12)');
uimenu(mens1,...
'Label','reduce by 2',...
'Callback','deftfaux(18)');
uimenu(mens2,...
'Label','enlarge by 1 tick',...
'Callback','deftfaux(13)');
uimenu(mens2,...
'Label','enlarge by 2',...
'Callback','deftfaux(19)');
uimenu(mens2,...
'Label','reduce by 1 tick',...
'Callback','deftfaux(14)');
uimenu(mens2,...
'Label','reduce by 2',...
'Callback','deftfaux(20)');
%
uimenu(mens3,...
'Label','enlarge by 1 tick',...
'Callback','deftfaux(15)');
uimenu(mens3,...
'Label','enlarge by 2',...
'Callback','deftfaux(21)');
uimenu(mens3,...
'Label','reduce by 1 tick',...
'Callback','deftfaux(16)');
uimenu(mens3,...
'Label','reduce by 2',...
'Callback','deftfaux(22)');
uimenu(mens,...
'Label','zoom in','Separator','on',...
'Callback','deftfaux(23)');
uimenu(mens,...
'Label','zoom out',...
'Callback','deftfaux(24)');
%
BB=VFULL(4)-24;
%
Pos=[4 BB 114 20]*SC;
pbs(1)=uicontrol(gcf,...
'Style','text',...
'String','Functions:',...
'Visible','off',...
'Position',Pos);
%
for kk=0:9 % 2->11
 Pos=[4 BB-20*(kk+1) 114 20]*SC;
 pbs(2+kk)=uicontrol(gcf,...
 'Style','push',...
 'Position',Pos,...
 'Visible','off');
end
Pos=[20 5 50 20]*SC;
pbs(12)=uicontrol(gcf,...
'Style','push',...
'Position',Pos,...
'String','Exit',...
'Visible','on',...
'Callback','commandwindow');
%
BB=VFULL(4)-14;
llth=500;
for kk=0:1 % 21->22
 Pos=[128 BB-15*kk llth 15]*SC;
 pbs(21+kk)=uicontrol(gcf,...
 'Style','text',...
 'Position',Pos,...
 'HorizontalAlignment','left',...
 'BackgroundColor',colbg,...
 'Visible','off');
end
%
llth=110;
BB=VFULL(4)-14;
for kk=0:2 % 13->15
 Pos=[10 BB-240-20*kk llth 15]*SC;
 pbs(13+kk)=uicontrol(gcf,...
 'Style','text',...
 'Position',Pos,...
 'HorizontalAlignment','left',...
 'BackgroundColor',colbg,...
 'Visible','off');
end
%
llth=140;
for kk=0:1 % 16->17
 Pos=[10 BB-300-15*kk llth 15]*SC;
 pbs(16+kk)=uicontrol(gcf,...
 'Style','text',...
 'Position',Pos,...
 'HorizontalAlignment','left',...
 'BackgroundColor',colbg,...
 'Visible','off');
end
%
mx1='PRESS RETURN TO EXIT';
mx2='BUTTON 1 TO REPEAT, BUTTON 2 TO ACCEPT';
Pos=[10 5 500 15]*SC;
pbs(20)=uicontrol(gcf,...
'Style','text',...
'Position',Pos,...
'HorizontalAlignment','left',...
'BackgroundColor',colbg,...
'ForegroundColor',vcol2(9,:),...
'Visible','off',...
'String',mx2);
%
set(pbs(1),'Visible','on')
set(pbs(2),'String','Add zeros','Visible','on','Callback','deftfaux(1)')
set(pbs(3),'String','Remove zeros','Visible','on','Callback','deftfaux(2)')
set(pbs(3),'Enable','off')
set(pbs(4),'String','Add poles','Visible','on','Callback','deftfaux(3)')
set(pbs(5),'String','Remove poles','Visible','on','Callback','deftfaux(4)')
set(pbs(5),'Enable','off')
set(pbs(6),'String','Set Ks to one','Visible','on','Callback','deftfaux(5)')
set(pbs(7),'String','Reset this map','Visible','on','Callback','deftfaux(6)')
set(pbs(8),'String','Another z/p map','Visible','on','Callback','deftfaux(7)')
set(pbs(9),'String','Reset all','Visible','on','Callback','deftfaux(10)')
set(pbs(10),'String','Step response','Visible','on','Callback','deftfaux(8)')
set(pbs(11),'String','Bode diagrams','Visible','on','Callback','deftfaux(9)')
mess1=['You can introduce any zero-pole map with mouse. ',...
'The gain K is set to one.'];
set(pbs(21),'String',mess1,'ForegroundColor',vcol2(9,:),'Visible','on')
mess2='Note that it is possible to set to one the dc gain Ks instead of K.';
set(pbs(22),'String',mess2,'ForegroundColor',vcol2(9,:),'Visible','on')
%mess=sprintf('K = %.3g',kdata);
%set(pbs(13),'String',mess,'ForegroundColor',vcol2(1,:),'Visible','on')
%set(pbs(16),'ForegroundColor',vcol2(1,:),'Visible','on')
%set(pbs(17),'ForegroundColor',vcol2(1,:),'Visible','on')
%set(pbs(20),'Visible','on')
mess=sprintf('K = %.3g',kcomp);
set(pbs(13),'String',mess,'ForegroundColor',vcol2(ncol,:),'Visible','on')
mess=sprintf('Ks = %.3g',kcomps);
set(pbs(14),'String',mess,'ForegroundColor',vcol2(ncol,:),'Visible','on')
nz=length(zcomp); np=length(pcomp);
mess=sprintf('nz = %i',nz); mess=[mess,sprintf(', np = %i',np)];
set(pbs(15),'String',mess,'ForegroundColor',vcol2(ncol,:),'Visible','on')
%
if str=='s'
 VV=[-5 1 -2 2];
else
 VV=[-2 2 -1.5 1.5];
end
%
if str=='z', TSAMP=lsamp; end
%
hold on
plot([0,0],[-10^8,10^8],'Color',vcol1(7,:),'LineStyle',':')
plot([-10^8,10^8],[0,0],'Color',vcol1(7,:),'LineStyle',':')
if str=='z'
 ang=2*pi*linspace(0,1,200); circ=cos(ang)+j*sin(ang);
 plot(circ,'Color',vcol1(7,:),'LineStyle',':')
end
axis(VV), set(gca,'Box','on')
PO=get(gca,'Position');
pp(1)=PO(1)+.12; pp(2)=PO(2); pp(3)=PO(3)-.1; pp(4)=PO(4)-.02;
set(gca,'Position',pp)
figure(nfig), hold off
xyx=input(['\n   **** figure ',nfigs,' **** '],'s');
cc=get(0,'Children');
if (any(cc==nfig))&(any(cc==nfig1))&(any(cc==nfig2))
 FIGLO(4,1:4)=get(nfig,'Position');
 FIGLO(4,5:8)=get(nfig1,'Position');
 FIGLO(4,9:12)=get(nfig2,'Position');
 save figlo# FIGLO -v4
else
 disp(' '), disp('   A FIGURE HAS BEEN DELETED!'), return
end
clc
if ncol>1
 xx=0;
 while xx==0
  col=input('\n   select function by entering color : ','s');
  if isempty(col), col='z'; end
  if col=='0', return, end
  ropc=0; for kk=1:7, ropc=ropc|strcmp(col,repco(kk)); end
  if ropc
   if find(repco==col)<=ncol
    xx=1;
   end
  end
 end
else
 col=repco(1);
end
q=find(repco==col);
eval(['numc=stkn',int2str(q),';'])
eval(['denc=stkd',int2str(q),';'])
[zc,pc,kc]=tozpk(numc,denc);
if str=='s'
 aa=importf(zc,pc,kc,gj);
else
 aa=importf(zc,pc,kc,gj,1);
end
if aa==1, tfg(gj), end
FIGLEG=0; set(nfig,'Color',framesc)
delete(men_gr), delete(mens)
eval('delete(nfig1)','err=1;'), eval('delete(nfig2)','err=1;')
for kk=1:22, eval('delete(pbs(kk))','err=1;'), end
set(gca,'Position',PO)
set(0,'DefaultUIControlUnits','pixel'), ordf(1)
% --- last line of deftfmou ---
