function aa=stf(Num,Den,k,str,gi,Tc)
%STF      Saves a transfer function (aux for TFI).
%   STF(Num,Den,k,str,'gi') saves Num,Den,k,str ('s' or 'z') in file gi.mat.
%   Optional logic output aa=STF(....) means "saving without error".

% TFI Environment (A.Civolani & G.Marro) - 1994-96. Matlab5 version, 1997.

[Num,Den,k]=ridg(Num,Den,k);
if nargin==5
 if str=='s', Tc=0; else, Tc=lsamp; end
end
[n,an]=sort(sum(abs(Num'))); [d,ad]=sort(sum(abs(Den')));
Numc=Num(an,:); Denc=Den(ad,:); kc=k; strc=str;
aa=1;
aa=aa & ~any(gi=='_');
aa=aa & ~any(gi=='(');
aa=aa & ~any(gi==')');
aa=aa & ~any(gi=='^');
aa=aa & ~any(gi=='&');
aa=aa & ~any(gi=='#');
aa=aa & ~any(gi=='%');
aa=aa & ~((abs(gi(1))>=48)&(abs(gi(1))<=57));
if aa, eval(['save ',gi,' Numc Denc kc strc Tc -v4'],'aa=0;'), end
if ~aa, disp(' '), disp([' **** name ',gi,' is illegal']), end
% --- last line of stf ---
