function tt=tfgg(arg1,arg2,arg3,arg4)
%TFGG	   Transfer function display (aux for TFI).
%   tt=TFGG('gi') produces a string to show transfer function gi.

% TFI Environment (A.Civolani & G.Marro) - 1994-96. Matlab5 version, 1997.

if nargin==0
 flg=0;
 while flg==0
  gi=input('\n   enter transfer function : ','s');
  if ~isempty(gi)
   if ~exist([gi,'.mat'])
    disp([' **** error: ',gi,'.mat does not exist'])
   else
    flg=1;
   end
  end
 end
else
 if ~exist([arg1,'.mat'])
  disp([' **** error: ',arg1,'.mat does not exist']), return
 else
  gi=arg1;
 end
end
tt=[];
[Num,Den,k,str]=ltf(gi);
tt=[tt,sprintf('|')];
[egv1,mul1,egv2,mul2,k]=ordg(Num,Den,k);
kl=length(sprintf('%.4g',k)); gl=length(gi)+3;
for hh=1:gl, tt=[tt,sprintf(' ')]; end
i=4; nzpl=[]; vnil=[]; nz1=[]; nz2=[];
%
% max. length of expression
%
dimaxes=get(gca,'Position');
len=round(74*dimaxes(3));
%
for i=4:-1:1
 index=0; nzpl1=0;
 if (i==2)|(i==4)
  e=egv1; m=mul1; nil=kl;
 elseif (i==1)|(i==3)
  e=egv2; m=mul2; nil=0;
 end
 if i==2, tt=[tt,sprintf('%.4g',k)]; end
 le=size(e);
 if (i==3)|((i==4)&(le(2)~=1))
  for nr=1:le(1)
   g=e(nr,:); q=find(g~=0);
   kk=le(2); ncm=length(sprintf('%.4g',m(nr)));
   while kk~=0
    if g(le(2)+1-kk)~=0
     nt=length(sprintf('%.4g',abs(g(le(2)+1-kk))));
     nc=length(sprintf('%.4g',kk-1));
     if (le(2)+1-kk)==q(1)
      if (nr~=1)|((nr==1)&(i==4)), nil=nil+1; end
      if length(q)>1, nil=nil+1; end
     end
     if ((le(2)+1-kk)~=q(1))|(((le(2)+1-kk)==q(1))&(g(le(2)+1-kk)<0))
      nil=nil+3;
     end
     if (abs(g(le(2)+1-kk))~=1)|((abs(g(le(2)+1-kk))==1)&(kk-1==0))
      nil=nil+nt;
     end
     if kk-1>0
      if abs(g(le(2)+1-kk))~=1
       nil=nil+2;
      else
       nil=nil+1;
      end
     end
     if (kk==1)&(nr==le(1)), inc=1; else, inc=0; end
     if kk-1>1, nil=nil+1+nc; end
     nzpl1=[nzpl1,nil];
     if nil>(len-gl-inc)
      nil=nzpl1(length(nzpl1))-nzpl1(length(nzpl1)-1)-1;
      nzpl=[nzpl,nzpl1(length(nzpl1)-1)];
      vnil=[vnil,diff(nzpl1)]; nzpl1=nil;
     end
    end
    kk=kk-1;
   end % while kk
   if length(q)>1, nil=nil+1; end
   if (m(nr)>1)&(length(find(g~=0))>0)
    nil=nil+1+ncm;
   end
   nzpl1=[nzpl1,nil]; nzpl=[nzpl,nil];
  end % for nr
  if i==4
   vnil1=[vnil,diff(nzpl1)];
   xx=0; vnil=[];
   for kk=1:length(vnil1)
    if (xx+vnil1(kk))<=max(nzpl)
     xx=xx+vnil1(kk);
    else
     nz1=[nz1,xx]; xx=vnil1(kk)-1;
    end
   end
   nz1=[nz1,xx];
  else
   vnil2=[vnil,diff(nzpl1)]; xx=0;
   for kk=1:length(vnil2)
    if (xx+vnil2(kk))<=max(nzpl)
     xx=xx+vnil2(kk);
    else
     nz2=[nz2,xx]; xx=vnil2(kk)-1;
    end
   end
   nz2=[nz2,xx];
  end
 elseif (i==1)|((i==2)&(le(2)~=1))
  if i==2, nz=nz1; else, nz=nz2; end
  index=index+1;
  for nr=1:le(1)
   g=e(nr,:);
   q=find(g~=0);
   kk=le(2);
   ncm=length(sprintf('%.4g',m(nr)));
   while kk~=0
    len=nz(index);
    if abs(g(le(2)+1-kk))>0
     nt=length(sprintf('%.4g',abs(g(le(2)+1-kk))));
     nc=length(sprintf('%.4g',kk-1));
     if g(le(2)+1-kk)>0
      sgn=(' + ');
     elseif g(le(2)+1-kk)<0
      sgn=(' - ');
     end
     if (le(2)+1-kk)==q(1)
      if (nr~=1)|((nr==1)&(i==2))
       tt=[tt,sprintf(' ')]; nil=nil+1;
      end
      if length(q)>1
       tt=[tt,sprintf('(')]; nil=nil+1;
      end
     end
     if ((le(2)+1-kk)~=q(1))|(((le(2)+1-kk)==q(1))&(g(le(2)+1-kk)<0))
      tt=[tt,sprintf(sgn)]; nil=nil+3;
     end
     if (abs(g(le(2)+1-kk))~=1)|((abs(g(le(2)+1-kk))==1)&(kk-1==0))
      tt=[tt,sprintf('%.4g',abs(g(le(2)+1-kk)))]; nil=nil+nt;
     end
     if kk-1>0
      if abs(g(le(2)+1-kk))~=1
       tt=[tt,sprintf('*')]; tt=[tt,sprintf(str)]; nil=nil+2;
      else
       tt=[tt,sprintf(str)]; nil=nil+1;
      end
     end
     if kk-1>1, tt=[tt,sprintf('^%.4g',kk-1)]; nil=nil+1+nc; end
     if (nil>=len)&(index<length(nz))
      index=index+1; nil=-1;
      tt=[tt,sprintf('|')];
      for hh=1:gl-1, tt=[tt,sprintf(' ')]; end
      if kk==1, tt=[tt,sprintf(' ')]; end
     end
    end
    kk=kk-1;
   end
   if length(q)>1
    tt=[tt,sprintf(')')]; nil=nil+1;
   end
   if (m(nr)>1)&(length(find(g~=0))>0)
    tt=[tt,sprintf('^%.4g',m(nr))]; nil=nil+1+ncm;
   end
   if (nil>=len)&(nr~=le(1))&(index<length(nz))
    index=index+1; nil=-1;
    tt=[tt,sprintf('|')];
    for hh=1:gl-1, tt=[tt,sprintf(' ')]; end
   end
  end
 end
 if i==2
  tt=[tt,sprintf('|')]; tt=[tt,sprintf(gi)]; tt=[tt,sprintf(' = ')];
  for in=1:max([nz1,nz2,kl]), tt=[tt,sprintf(setstr(173))]; end
  tt=[tt,sprintf('|')];
  for hh=1:gl, tt=[tt,sprintf(' ')]; end
 end
end
tt=[tt,sprintf('|')];
% --- last line of tfgg ---
